%{!?upstream_version: %global upstream_version %{version}%{?milestone}}
%global with_doc %{!?_without_doc:1}%{?_without_doc:0}

%if 0%{?fedora} > 23
%global with_python3 1
%endif

%global service sahara-tests
%global pkgname sahara
Name:           openstack-%{service}
Version:        0.7.0
Release:        1%{?dist}
Summary:        Sahara Scenario Test Framework
License:        ASL 2.0
URL:            http://launchpad.net/%{service}/

Source0:        https://tarballs.openstack.org/%{service}/%{service}-%{upstream_version}.tar.gz
BuildArch:      noarch

BuildRequires:  git
BuildRequires:  openstack-macros

%description
This project contains Sahara-scenario test framework.

%package -n python-%{pkgname}-tempest
Summary:        OpenStack Sahara tempest plugin common library
%{?python_provide:%python_provide python-%{pkgname}-tempest}
Obsoletes:      openstack-%{service} < 0.6.0
Provides:       openstack-%{service} = %{version}-%{release}

BuildRequires:  python-devel
BuildRequires:  python-pbr
BuildRequires:  python-setuptools

# test dependencies requirements
BuildRequires:    python-mock
BuildRequires:    python-testtools
BuildRequires:    python-jsonschema
BuildRequires:    python-oslo-utils
BuildRequires:    python-saharaclient
BuildRequires:    python-tempest
BuildRequires:    python-swiftclient
BuildRequires:    python-stestr

Requires:       python-pbr
%if 0%{?fedora} > 0
Requires:       python-mako
BuildRequires:  python-mako
%else
Requires:       python-mako
BuildRequires:  python-mako
%endif
Requires:       python-fixtures
Requires:       python-jsonschema
Requires:       python-oslo-concurrency >= 3.5.0
Requires:       python-oslo-serialization >= 1.10.0
Requires:       python-oslo-utils >= 3.5.0
Requires:       python-oslotest >= 1.10.0
Requires:       python-stestr >= 1.0.0
Requires:       python-paramiko
Requires:       python-keystoneauth1 >= 2.1.0
Requires:       python-glanceclient >= 1:2.0.0
Requires:       python-novaclient >= 1:2.29.0
Requires:       python-saharaclient >= 0.13.0
Requires:       python-swiftclient >= 2.2.0
Requires:       python-neutronclient >= 4.2.0
Requires:       python-rfc3986
Requires:       python-six
Requires:       python-tempest >= 16.0.0
Requires:       python-testtools

%description -n python-%{pkgname}-tempest
This project contains OpenStack Sahara tests tempest plugin common library.

%package -n python-%{service}-tempest
Summary:        OpenStack Sahara tempest plugin
%{?python_provide:%python_provide python-%{service}-tempest}

Requires:       python-%{pkgname}-tempest = %{version}-%{release}

%description -n python-%{service}-tempest
This project contains OpenStack Sahara tests tempest plugin

%package -n python-%{service}-scenario
Summary:        OpenStack Sahara test scenario plugin
%{?python_provide:%python_provide python-%{service}-scenario}

Requires:       python-%{pkgname}-tempest = %{version}-%{release}
Requires:       python-os-client-config >= 1.13.1

%description -n python-%{service}-scenario
This project contains OpenStack Sahara tests scenario plugin

%if 0%{?with_python3}
%package -n python3-%{pkgname}-tempest
Summary:        OpenStack Sahara tempest plugin common library
%{?python_provide:%python_provide python3-%{pkgname}-tempest}

BuildRequires:  python3-devel
BuildRequires:  python3-pbr
BuildRequires:  python3-setuptools

# test dependencies requirements
BuildRequires:    python3-mock
BuildRequires:    python3-testtools
BuildRequires:    python3-jsonschema
BuildRequires:    python3-oslo-utils
BuildRequires:    python3-saharaclient
BuildRequires:    python3-tempest
BuildRequires:    python3-swiftclient
BuildRequires:    python3-mako
BuildRequires:    python3-stestr

Requires:       python3-pbr
Requires:       python3-mako
Requires:       python3-fixtures
Requires:       python3-jsonschema
Requires:       python3-oslo-concurrency >= 3.5.0
Requires:       python3-oslo-serialization >= 1.10.0
Requires:       python3-oslo-utils >= 3.5.0
Requires:       python3-oslotest >= 1.10.0
Requires:       python3-stestr >= 1.0.0
Requires:       python3-paramiko
Requires:       python3-keystoneauth1 >= 2.1.0
Requires:       python3-glanceclient >= 1:2.0.0
Requires:       python3-novaclient >= 1:2.29.0
Requires:       python3-saharaclient >= 0.13.0
Requires:       python3-swiftclient >= 2.2.0
Requires:       python3-neutronclient >= 4.2.0
Requires:       python3-rfc3986
Requires:       python3-six
Requires:       python3-tempest >= 16.0.0
Requires:       python3-testtools

%description -n python3-%{pkgname}-tempest
This project contains OpenStack Sahara tests tempest plugin common library.

%package -n python3-%{service}-tempest
Summary:        OpenStack Sahara tempest plugin
%{?python_provide:%python_provide python3-%{service}-tempest}

Requires:       python3-%{pkgname}-tempest = %{version}-%{release}

%description -n python3-%{service}-tempest
This project contains OpenStack Sahara tests tempest plugin

%package -n python3-%{service}-scenario
Summary:        OpenStack Sahara test scenario plugin
%{?python_provide:%python_provide python3-%{service}-scenario}

Requires:       python3-%{pkgname}-tempest = %{version}-%{release}
Requires:       python3-os-client-config >= 1.13.1
%description -n python3-%{service}-scenario
This project contains OpenStack Sahara tests scenario plugin
%endif

%if 0%{?with_doc}
%package doc
Summary:          Documentation for OpenStack Sahara Tests

BuildRequires:    python-sphinx
BuildRequires:    python-openstackdocstheme
BuildRequires:    python-reno

%description      doc
This package contains the openstack sahara-tests Documentation files.
%endif

%prep
%autosetup -n %{service}-%{upstream_version} -S git

# Let RPM handle the dependencies
%py_req_cleanup
chmod +x sahara_tests/scenario/runner.py
chmod +x sahara_tests/scenario/defaults/edp-examples/edp-shell/shell-example.sh

%build
%if 0%{?with_python3}
%py3_build
%endif
%py2_build

# docs generation
%if 0%{?with_doc}
%{__python} setup.py build_sphinx
# Fix hidden-file-or-dir warnings
rm -fr doc/build/html/.doctrees doc/build/html/.buildinfo
# Remove zero-length files
find doc/build/html -size 0 -delete
%endif

%install
%if 0%{?with_python3}
%py3_install
mv %{buildroot}%{_bindir}/sahara-scenario %{buildroot}%{_bindir}/sahara-scenario-%{python3_version}
ln -s ./sahara-scenario-%{python3_version} %{buildroot}%{_bindir}/sahara-scenario-3
%endif
%py2_install

install -d -m 755 %{buildroot}%{_sysconfdir}/
mv %{buildroot}/usr/etc/* %{buildroot}%{_sysconfdir}/

%check
export OS_TEST_PATH='./sahara_tests/unit/scenario'
export PATH=$PATH:$RPM_BUILD_ROOT/usr/bin
export PYTHONPATH=$PWD
stestr --test-path $OS_TEST_PATH run

%if 0%{?with_python3}
rm -rf .stestr
stestr-3 --test-path $OS_TEST_PATH run
%endif

%files -n python-%{pkgname}-tempest
%doc README.rst
%license LICENSE
%{python_sitelib}/sahara_tests
%{python_sitelib}/sahara_tests-*.egg-info
%exclude %{python_sitelib}/sahara_tests/scenario
%exclude %{python_sitelib}/sahara_tests/unit/scenario
# moving sahara-scenario and sahara_tempest_plugin
# to python-sahara-tests-tempest and python-sahara-tests-scenario
%exclude %{_bindir}/sahara-scenario
%exclude %{python_sitelib}/sahara_tempest_plugin
%exclude %{_sysconfdir}/sahara-scenario/*

%files -n python-%{service}-tempest
%license LICENSE
%{python_sitelib}/sahara_tempest_plugin

%files -n python-%{service}-scenario
%license LICENSE
# FIXME /sahara_tests/scenario/defaults contains jar file
# We are need to find a way to build the jar files properly
# https://trello.com/c/jDJnTO22/305-sahara-tests-jar-unbundling-tracker
%{python_sitelib}/sahara_tests/scenario
%{python_sitelib}/sahara_tests/unit/scenario
%{_bindir}/sahara-scenario
%config(noreplace) %{_sysconfdir}/sahara-scenario/*

%if 0%{?with_python3}
%files -n python3-%{pkgname}-tempest
%doc README.rst
%license LICENSE
%{python3_sitelib}/sahara_tests
%{python3_sitelib}/sahara_tests-*.egg-info
%exclude %{python3_sitelib}/sahara_tests/scenario
%exclude %{python3_sitelib}/sahara_tests/unit/scenario
%exclude %{python3_sitelib}/sahara_tempest_plugin

%files -n python3-%{service}-tempest
%license LICENSE
%{python3_sitelib}/sahara_tempest_plugin

%files -n python3-%{service}-scenario
%license LICENSE
# FIXME /sahara_tests/scenario/defaults contains jar file
# We are need to find a way to build the jar files properly
# https://trello.com/c/jDJnTO22/305-sahara-tests-jar-unbundling-tracker
%{python3_sitelib}/sahara_tests/scenario
%{python3_sitelib}/sahara_tests/unit/scenario
%{_bindir}/sahara-scenario-3
%{_bindir}/sahara-scenario-%{python3_version}
%config(noreplace) %{_sysconfdir}/sahara-scenario/*
%endif

%if 0%{?with_doc}
%files doc
%license LICENSE
%doc doc/build/html
%endif

%changelog
* Tue Sep 25 2018 RDO <dev@lists.rdoproject.org> 0.7.0-1
- Update to 0.7.0

* Thu Aug 23 2018 Chandan Kumar <chkumar@redhat.com> 0.6.1-0.1.g2e8e1556it
- Update to pre-release 0.6.1 (2e8e1556733289820a4cef732aca608b914d9112)
